SystemOrganization addCategory: 'JASVGI-Graphics'!

JASVGICanvas subclass: #JASVGIGraphCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Graphics'!

!JASVGIGraphCanvas commentStamp: '' prior: 0!
Methods name convention order:
at
id
r
rx
ry
width
height
widthPx
strokeWidth
stroke
fillColor
color!

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 14:32'!
example1
 | dict |

	dict := Dictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 30;
		at: 'china' put: 28;
		at: 'india' put: 25.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawVerticalBarGraph: dict at: 10@20 maxHeight: 180 width: 30)
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:14'!
example10
 | dict splitDict |

	splitDict := OrderPreservingDictionary new.
	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 50;
		at: 'china' put: 28;
		at: 'uruguay' put: 44;
		at: 'india' put: 25.

	splitDict at: 'rusia' put: (OrderPreservingDictionary new at: 'moscow' put: 30; at: 'st pertersburg' put: 20; at: 'vladigostok' put: 10;yourself);
		at: 'usa' put: (OrderPreservingDictionary new at: 'new york' put: 20; at: 'los angeles' put: 6; at: 'oregon' put: 14; at: 'orlando' put: 10; yourself);
		at: 'china' put: (OrderPreservingDictionary new at: 'pekin' put: 24; at: 'hong kong' put: 4; yourself);
		at: 'uruguay' put: (OrderPreservingDictionary new at: 'montevideo' put: 20; at: 'las piedras' put: 24; yourself);
		at: 'india' put: (OrderPreservingDictionary new at: 'new delhi' put: 15; at: 'bombay' put: 8; at: 'mumba' put: 2 ;yourself).

	^((self newWidth: '1000px' height: '1000px') 
			drawJoin: splitDict 
			verticalBarGraph: dict 
			at: 15@15 
			maxHeight: 200 
			width: 20 
			transform: 'translate(50,400),scale(1.5,1.5)') 
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example11
 | dict splitDict |

	splitDict := OrderPreservingDictionary new.
	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 50;
		at: 'china' put: 28;
		at: 'uruguay' put: 44;
		at: 'india' put: 25.

	splitDict at: 'rusia' put: (OrderPreservingDictionary new at: 'moscow' put: 30; at: 'st pertersburg' put: 20; at: 'vladigostok' put: 10;yourself);
		at: 'usa' put: (OrderPreservingDictionary new at: 'new york' put: 20; at: 'los angeles' put: 6; at: 'oregon' put: 14; at: 'orlando' put: 10; yourself);
		at: 'china' put: (OrderPreservingDictionary new at: 'pekin' put: 24; at: 'hong kong' put: 4; yourself);
		at: 'uruguay' put: (OrderPreservingDictionary new at: 'montevideo' put: 20; at: 'las piedras' put: 24; yourself);
		at: 'india' put: (OrderPreservingDictionary new at: 'new delhi' put: 15; at: 'bombay' put: 8; at: 'mumba' put: 2 ;yourself).

	^((self newWidth: '1000px' height: '1000px') 
			drawJoin: splitDict 
			horizontalBarGraph: dict 
			at: 15@15 
			maxWidth: 200 
			width: 20 
			transform: 'translate(20,20),scale(1.5,1.5)') 
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:35'!
example12
 | dict splitDict |

	splitDict := OrderPreservingDictionary new.
	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 50;
		at: 'china' put: 28;
		at: 'uruguay' put: 44;
		at: 'india' put: 25.

	splitDict at: 'rusia' put: (OrderPreservingDictionary new at: 'moscow' put: 30; at: 'st pertersburg' put: 20; at: 'vladigostok' put: 10;yourself);
		at: 'usa' put: (OrderPreservingDictionary new at: 'new york' put: 20; at: 'oregon' put: 14; at: 'orlando' put: 10; at: 'los angeles' put: 6; yourself);
		at: 'china' put: (OrderPreservingDictionary new at: 'pekin' put: 24; at: 'hong kong' put: 4; yourself);
		at: 'uruguay' put: (OrderPreservingDictionary new at: 'montevideo' put: 23; at: 'las piedras' put: 21; yourself);
		at: 'india' put: (OrderPreservingDictionary new at: 'new delhi' put: 15; at: 'bombay' put: 8; at: 'mumba' put: 2 ;yourself).

	^((self newWidth: '1000px' height: '1000px') 
			drawJoin: splitDict 
			horizontalBarGraph: dict 
			at: 15@15 
			maxWidth: 400 
			width: 15
			transform: 'translate(20,10),scale(1.5,1.5)') 
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/23/2016 05:06'!
example13
 | dict canvas |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px' backcolor: 'lightgray'.
	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 80;
		at: 'md' put: 70;
		at: 'mef' put: 50;
		at: 'opp' put: 50;
		at: 'msp' put: 50;
		at: 'mt' put: 60.	
	canvas
		drawDonutAngles: dict 
		at: 10@10 
		radius: 80
		width: 60
		backcolor: 'white'
		transform: 'translate(100,100)'.

	canvas
		drawDonutAngles: dict 
		at: 10@10 
		radius: 80
		width: 50
		backcolor: 'white'
		transform: 'translate(400,100)'.

	canvas
		drawDonutAngles: dict 
		at: 10@10 
		radius: 80
		width: 40
		backcolor: 'white'
		transform: 'translate(100,300)'.

	canvas
		drawDonutAngles: dict 
		at: 10@10 
		radius: 80
		width: 30
		backcolor: 'white'
		transform: 'translate(400,300)'.

	^canvas contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/29/2016 05:15'!
example14
 | dict canvas workingDays |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px' backcolor: 'lightgray'.
	dict := OrderPreservingDictionary new.
	workingDays := Dictionary new.
	workingDays at: 1 put: 20; at: 2 put: 15; at: 3 put: 8; at: 4 put: 30; at: 5 put: 22; at: 6 put: 15; at: 7 put: 30; at: 8 put: 4; at: 9 put: 19; at: 10 put: 8; at: 11 put: 14; 
at: 12 put: 1; at: 13 put: 4; at: 14 put: 28; at: 15 put: 22; at: 28 put: 15; at: 45 put: 17; at: 53 put: 22; at: 60 put: 8; at: 70 put: 9; at: 75 put: 8; at: 83 put: 19; at: 90 put: 17;
at: 103 put: 21; at: 115 put: 12; at: 160 put: 26; at: 175 put: 17.
 	canvas drawVerticalDaysAt: 30@30 
				from: (Date fromString: '09/30/2016')
				to: ((Date fromString: '09/30/2016') addDays: 365) 
				workingDays: workingDays
				width: 10 
				color: 'green'.

	^canvas contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/29/2016 05:17'!
example15
 | dict canvas workingDays |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px' backcolor: 'lightgray'.
	dict := OrderPreservingDictionary new.
	workingDays := Dictionary new.
	workingDays at: 1 put: 20; at: 2 put: 15; at: 3 put: 8; at: 4 put: 30; at: 5 put: 22; at: 6 put: 15; at: 7 put: 30; at: 8 put: 4; at: 9 put: 19; at: 10 put: 8; at: 11 put: 14; 
at: 12 put: 1; at: 13 put: 4; at: 14 put: 28; at: 15 put: 22; at: 21 put: 15; at: 23 put: 17; at: 25 put: 22; at: 28 put: 8; at: 29 put: 9; at: 30 put: 17.

 	canvas drawVerticalDaysAt: 30@30 
				from: (Date fromString: '09/01/2016')
				to: (Date fromString: '09/30/2016')
				workingDays: workingDays
				width: 20 
				color: 'green'.

	^canvas contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 10/10/2016 13:46'!
example16
	| dict canvas sd |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px' backcolor: 'lightgray'.
	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 80;
		at: 'mef' put: 70;
		at: 'opp' put: 100;
		at: 'msp' put: 50;
		at: 'mt' put: 60.	
	sd := OrderPreservingDictionary new.
	sd at: 'miem-1' put: 40; at: 'miem-2' put: 40; at: 'mef-1' put: 30; at: 'mef-2' put: 30; 
at: 'mef-3' put: 10; at: 'opp-1' put: 40; at: 'opp-2' put: 15; at: 'opp-3' put: 15; at: 'opp-4' put: 10; 
at: 'opp-5' put: 10; at: 'opp-6' put: 10; at: 'msp-1' put: 30;at: 'msp-2' put: 20; at: 'mt-1' put: 20; 
at: 'mt-2' put: 30; at: 'mt-3' put: 10.

	canvas
		drawDoubleDonutAngles: dict 
		subAngles: sd 
		at: 10@10
		radius: 80 
		backcolor: 'lightgray' 
		transform: 'translate(150,150)'.

	^canvas contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example2
 | dict |

	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 30;
		at: 'usa' put: 25;
		at: 'china' put: 20;
		at: 'india' put: 20;
		at: 'vietnam' put: 5.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawPiesDesc: dict at: 120@120 zoom: 1) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example3
 | dict |

	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 80;
		at: 'md' put: 70;
		at: 'mef' put: 50;
		at: 'opp' put: 50;
		at: 'msp' put: 50;
		at: 'mt' put: 60.	

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawPieAngles: dict at: 10@10 radius: 80) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 07:41'!
example4
 | dict |

	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 45;
		at: 'md' put: 20;
		at: 'mef' put: 15;
		at: 'opp' put: 10;
		at: 'msp' put: 5;
		at: 'mt' put: 5.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawPiePercentage: dict at: 10@10 radius: 80) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example5
 | dict |

	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 30;
		at: 'china' put: 28;
		at: 'india' put: 25.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawVerticalBarGraph: dict at: 15@200 maxHeight: 180 width: 30) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example6
 | dict |

	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 30;
		at: 'china' put: 28;
		at: 'india' put: 25.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawHorizontalBarGraph: dict at: 15@15 maxWidth: 600 width: 30) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 16:04'!
example7
  | dict canvas |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px'.
	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 30;
		at: 'md' put: 20;
		at: 'mef' put: 15;
		at: 'opp' put: 10;
		at: 'msp' put: 5;
		at: 'mvotma' put: 8;
		at: 'mi' put: 7;
		at: 'mt' put: 5.

	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(100,100)'.
	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(100,300)'.
	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(450,100)'.
	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(450,300)'.

	^canvas contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example8
 | dict splitDict |

	splitDict := OrderPreservingDictionary new.
	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 50;
		at: 'china' put: 28;
		at: 'uruguay' put: 44;
		at: 'india' put: 25.

	splitDict at: 'rusia' put: (OrderPreservingDictionary new at: 'moscow' put: 30; at: 'st pertersburg' put: 20; at: 'vladigostok' put: 10;yourself);
		at: 'usa' put: (OrderPreservingDictionary new at: 'new york' put: 20; at: 'los angeles' put: 6; at: 'oregon' put: 14; at: 'orlando' put: 10; yourself);
		at: 'china' put: (OrderPreservingDictionary new at: 'pekin' put: 24; at: 'hong kong' put: 4; yourself);
		at: 'uruguay' put: (OrderPreservingDictionary new at: 'montevideo' put: 20; at: 'las piedras' put: 24; yourself);
		at: 'india' put: (OrderPreservingDictionary new at: 'new delhi' put: 15; at: 'bombay' put: 8; at: 'mumba' put: 2 ;yourself).

	^((self newWidth: '1000px' height: '1000px') 
			drawInnerSplit: splitDict 
			verticalBarGraph: dict 
			at: 15@15 
			maxHeight: 200 
			width: 30 
			transform: 'translate(50,400),scale(1.5,1.5)') 
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/21/2016 16:32'!
example9
 | dict splitDict |

	splitDict := OrderPreservingDictionary new.
	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 50;
		at: 'uruguay' put: 44;
		at: 'china' put: 28;
		at: 'india' put: 25.

	splitDict at: 'rusia' put: (OrderPreservingDictionary new at: 'moscow' put: 30; at: 'st pertersburg' put: 20; at: 'vladigostok' put: 10;yourself);
		at: 'usa' put: (OrderPreservingDictionary new at: 'new york' put: 20; at: 'oregon' put: 14; at: 'orlando' put: 10; at: 'los angeles' put: 6; yourself);
		at: 'china' put: (OrderPreservingDictionary new at: 'pekin' put: 24; at: 'hong kong' put: 4; yourself);
		at: 'uruguay' put: (OrderPreservingDictionary new at: 'montevideo' put: 23; at: 'las piedras' put: 21; yourself);
		at: 'india' put: (OrderPreservingDictionary new at: 'new delhi' put: 15; at: 'bombay' put: 8; at: 'mumba' put: 2 ;yourself).

	^((self newWidth: '1000px' height: '1000px') 
			drawInnerSplit: splitDict 
			horizontalBarGraph: dict 
			at: 15@15 
			maxWidth: 500 
			width: 20
			transform: 'translate(20,20),scale(1.4,1.4)') 
		contents! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 09/28/2016 07:46'!
colorPalette
	"Answer anArray with a list of color to be used by the receiver"

	^#('aliceblue' 'beige' 'brown' 'burlywood' 'cadetblue' 'chocolate' 'coral' 'cornsilk' 'crimson' 'darkcyan' 'darkgoldenrod' 'darkgray' 'darkgreen' 'darkkhaki' 'darkolivegreen'  'darkred' 'darkslateblue' 'darkslategray' 'firebrick' 'gold' 'goldenrod' 'gray' 'lightblue' 'indigo' 'ivory' 'khaki' 'lavender' 'lightcyan' 'lightgoldenrodyellow' 'lightgray' 'olive' 'peru' 'red' 'saddlebrown' 'steelblue' 'tan')! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/29/2016 07:11'!
drawDonutAngles: anglesDictionary at: aPoint radius: radius width: width backcolor: backcolor transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."
	| pie donuts |

	"self drawRectangleAt: 0@0 height: self height width: self width fillColor: backcolor stroke: 'none'."

	pie := self drawPieAngles: anglesDictionary at: aPoint radius: radius transform: transform.

	donuts := self drawCircleAt: 0@0 r: width stroke: 'black' fillColor: backcolor.

	donuts transform: transform.! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/23/2016 05:08'!
drawDonutPercentage: percentageDictionary at: aPoint radius: radius width: width backcolor: backcolor transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawDonutAngles: (percentageDictionary collect: [:per | (per * 360) / 100])
			at: aPoint
			radius: radius 
			width: width
			backcolor: backcolor 
			transform: transform! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/29/2016 07:09'!
drawDonutQuantity: quantityDictionary at: aPoint radius: radius width: width backcolor: backcolor transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."
	| pie donuts |

	pie := self drawPieQuantity: quantityDictionary at: aPoint radius: radius transform: transform.

	donuts := self drawCircleAt: 0@0 r: width stroke: 'black' fillColor: backcolor.

	donuts transform: transform.! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 13:48'!
drawDoubleDonutAngles: anglesDictionary subAngles: subAngles at: aPoint radius: radius backcolor: backcolor transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawDoubleDonutAngles: anglesDictionary subAngles: subAngles showSub: true at: aPoint radius: radius backcolor: backcolor transform: transform! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 13:51'!
drawDoubleDonutAngles: anglesDictionary subAngles: subAngles showSub: aBoolean at: aPoint radius: radius backcolor: backcolor transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."
	| dictionaries blankCircle colorDictionary subColorDictionary opacityDictionary maxValue mainDonutRadius |

	dictionaries := self getDictionaryOpacityColorFor: anglesDictionary subValues: subAngles.
	colorDictionary := dictionaries at: 1.
	subColorDictionary := dictionaries at: 2.
	opacityDictionary := dictionaries at: 3.
	maxValue := anglesDictionary asSortedCollection last.

	mainDonutRadius :=  aBoolean 
		ifTrue: [self drawPieAngles: subAngles at: aPoint radius: (radius * 1.5) colors: subColorDictionary opacityDictionary: opacityDictionary transform: transform maxValue: maxValue.
					radius]
		ifFalse: [radius * 1.5].	

	self drawPieAngles: anglesDictionary at: aPoint radius: mainDonutRadius colors: colorDictionary opacityDictionary: Dictionary new transform: transform maxValue: maxValue.

	blankCircle := self drawCircleAt: 0@0 r: (radius//2) stroke: 'black' fillColor: backcolor.
	blankCircle transform: transform.! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 11:09'!
drawDoublePieAngles: mainAnglesDictionary subAngles: subAnglesDictionary at: aPoint radius: radius transform: transform maxValue: maxValue
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."
	| colorsDictionary |

	colorsDictionary := self getDictionaryColorFor: mainAnglesDictionary.

	self drawPieAngles: mainAnglesDictionary at: aPoint radius: radius colors: colorsDictionary transform: transform maxValue: maxValue.! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/20/2016 04:09'!
drawHorizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph.
	The witdh of each bar is defined by <width>"

	^self drawHorizontalBarGraph: aDictionary 
			at: aPoint 
			maxWidth: maxWidth 
			width: width 
			transform: 'translate(20,20)'! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/28/2016 08:26'!
drawHorizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width transform: transform
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis xShift group axisRange groupName |

	groupName := 'horizontalBar'.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x.
	maxValue := aDictionary asSortedCollection last.
	"draw graph axis Y only"
	self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).

	axis := self drawLineFrom: x@y to: (x +  maxWidth + 20) @ y.
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	xShift := maxWidth // 5.
	axisRange := x + xShift.

	1 to: 5 do: [:index | | line text |
		"draw scale Y bar"
		line := self drawLineFrom: (axisRange @ (aPoint y - 5)) to: (axisRange @ (aPoint y + 5)).
		text := self drawText: (maxValue * index // 5) printString at: ((axisRange - 3) @ (aPoint x - 10)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName.
		axisRange := axisRange + xShift]. 

	"draw rectangle bars"
	y := y + 15.
	aDictionary keysAndValuesDo: [:key :value | | text text2 graph graphHeight |
		text := self drawText: key at: (x - 25) @ y textSizePx: '10px'.
		text2 := self drawText: value printString at: ((x - 25) @ (y + 10)) textSizePx: '10px'.
		graphHeight := value * maxWidth //  maxValue.
		graph := self drawRectangleAt: (x @ y) width: graphHeight height: width stroke: 'black' fillColor: self colorPalette randomPeek.
		self addFigure: graph toGroup: groupName.
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
		y := y + width + 10.
	].! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/21/2016 16:10'!
drawInnerSplit: splitDictionary horizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph."
	

	^self drawInnerSplit: splitDictionary 
			horizontalBarGraph: aDictionary 
			at: aPoint 
			maxWidth: maxWidth 
			width: width 
			transform: 'translate(20,20)'! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/28/2016 08:27'!
drawInnerSplit: splitDictionary horizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width transform: transform
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis xShift group axisRange groupName colorPalette |

	colorPalette := self colorPalette asOrderedCollection.
	groupName := 'horizontalBar'.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x.
	maxValue := aDictionary asSortedCollection last.
	"draw graph axis Y only"
	self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).

	axis := self drawLineFrom: x@y to: (x +  maxWidth + 20) @ y.
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	xShift := maxWidth // 5.
	axisRange := x + xShift.

	1 to: 5 do: [:index | | line text |
		"draw scale Y bar"
		line := self drawLineFrom: (axisRange @ (aPoint y - 5)) to: (axisRange @ (aPoint y + 5)).
		text := self drawText: (maxValue * index // 5) printString at: ((axisRange - 3) @ (aPoint x - 10)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName.
		axisRange := axisRange + xShift]. 

	"draw rectangle bars"
	y := y + 25.
	aDictionary keysAndValuesDo: [:key :value | | text text2 graphHeight splitX color opacity |
		text := self drawText: key at: (x - 25) @ y textSizePx: '10px'.
		text2 := self drawText: value printString at: ((x - 25) @ (y + 10)) textSizePx: '10px'.
		graphHeight := value * maxWidth //  maxValue.
		splitX := x.
		"graph := self drawRectangleAt: (x @ y) height: width width: graphHeight fillColor: self colorPalette randomPeek stroke: 'black'."
		opacity := 1.
		color := colorPalette randomPeek.
		colorPalette remove: color.
		colorPalette isEmpty ifTrue: [colorPalette := self colorPalette asOrderedCollection].
		(splitDictionary at: key) keysAndValuesDo: [:splitKey :splitValue | | splitText splitText2 innerWidth splitGraph |
			innerWidth := splitValue * maxWidth //  maxValue.
			splitGraph := self drawRectangleAt: (splitX @ y) width: innerWidth height: width stroke: 'black' fillColor: color.
			splitGraph add: (JASVGIAttribute parent: splitGraph name: 'fill-opacity' value: opacity printString).
			opacity := opacity - 0.2.
			splitText := self drawText: splitKey at: (((splitX + (innerWidth//2)) - 20) @ (y-8)) textSizePx: '6px'.
			splitText2 := self drawText: splitValue printString at: (((splitX + (innerWidth//2)) - 20) @ (y-3)) textSizePx: '6px'.
			self addFigure: splitGraph toGroup: groupName.
			self addFigure: splitText toGroup: groupName.
			self addFigure: splitText2 toGroup: groupName.
			splitX := splitX + innerWidth.
		]. 
		"self addFigure: graph toGroup: groupName."
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
		y := y + width + 20.
	].! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/21/2016 14:10'!
drawInnerSplit: splitDictionary verticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width
	"The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
	The witdh of each bar is defined by <width>"

	^self drawInnerSplit: splitDictionary 
			verticalBarGraph: aDictionary 
			at: aPoint maxHeight: maxHeight 
			width: width 
			transform: 'translate(20,', (maxHeight + 20) printString,')'! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/28/2016 08:27'!
drawInnerSplit: splitDictionary verticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width transform: transform
	"The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis yShift group groupName colorPalette |

	groupName := UUID new asString.
	colorPalette := self colorPalette asOrderedCollection.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x + 35.
	maxValue := aDictionary asSortedCollection last.
	"draw graph axis Y only"
	self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).
	axis := self drawLineFrom: aPoint to: (aPoint x @ (aPoint y -  maxHeight - 20)).
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	yShift := maxHeight // 5.
	1 to: 5 do: [:index | | axisRange line text |
		"draw scale Y bar"
		axisRange := y - (yShift * index) .
		line := self drawLineFrom: ((aPoint x - 5) @ axisRange) to: ((aPoint x + 5) @ axisRange).
		text := self drawText: (maxValue * index // 5) printString at: ((aPoint x - 10) @ (axisRange - 3)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName]. 

	"draw rectangle bars"
	aDictionary keysAndValuesDo: [:key :value | | text text2 graphHeight splitY color opacity |
		text := self drawText: key at: (x @ (y + 15)) textSizePx: '10px'.
		text2 := self drawText: value printString at: (x @ (y + 30)) textSizePx: '10px'.
		graphHeight := value * maxHeight //  maxValue.
		color := colorPalette randomPeek.
		colorPalette remove: color.
		colorPalette isEmpty ifTrue: [colorPalette := self colorPalette asOrderedCollection].
		opacity := 0.5.
"		graph := self drawRectangleAt: (x @ (y - graphHeight)) height: graphHeight width: width fillColor: self colorPalette randomPeek stroke: 'black'."
		splitY := y - graphHeight.
		(splitDictionary at: key) keysAndValuesDo: [:splitKey :splitValue | | splitText splitText2 innerHeight splitGraph |
			innerHeight := splitValue * maxHeight //  maxValue.
			splitGraph := self drawRectangleAt: (x @ splitY) width: width height: innerHeight stroke: 'black' fillColor: color.
			splitGraph add: (JASVGIAttribute parent: splitGraph name: 'fill-opacity' value: opacity printString).
			opacity := opacity + 0.2.
			splitY := splitY + innerHeight.
			splitText := self drawText: splitKey at: ((x-20) @ (splitY - (innerHeight//2))) textSizePx: '6px'.
			splitText2 := self drawText: splitValue printString at: ((x-20) @ (splitY + 8 - (innerHeight//2))) textSizePx: '6px'.
			self addFigure: splitGraph toGroup: groupName.
			self addFigure: splitText toGroup: groupName.
			self addFigure: splitText2 toGroup: groupName.
		]. 

	"	self addFigure: graph toGroup: groupName."
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
		x := x + width + 30.
	].! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/28/2016 08:27'!
drawJoin: joinDictionary horizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width transform: transform
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis xShift group axisRange groupName colorPalette |

	colorPalette := self colorPalette asOrderedCollection.
	groupName := 'horizontalBar'.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x.
	maxValue := 0.
	joinDictionary do: [:eachDict | | maxElem |
		maxElem := eachDict asSortedCollection asSortedCollection last.
		(maxElem > maxValue) ifTrue: [maxValue := maxElem]].
	"draw graph axis Y only"
	self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).

	axis := self drawLineFrom: x@y to: (x +  maxWidth + 20) @ y.
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	xShift := maxWidth // 5.
	axisRange := x + xShift.

	1 to: 5 do: [:index | | line text |
		"draw scale Y bar"
		line := self drawLineFrom: (axisRange @ (aPoint y - 5)) to: (axisRange @ (aPoint y + 5)).
		text := self drawText: (maxValue * index // 5) printString at: ((axisRange - 3) @ (aPoint x - 10)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName.
		axisRange := axisRange + xShift]. 

	"draw rectangle bars"
	y := y + 25.
	aDictionary keysAndValuesDo: [:key :value | | text text2 graphHeight color opacity |
		text := self drawText: key at: (x - 25) @ y textSizePx: '10px'.
		text2 := self drawText: value printString at: ((x - 25) @ (y + 10)) textSizePx: '10px'.
		graphHeight := value * maxWidth //  maxValue.
		opacity := 1.
		color := colorPalette randomPeek.
		colorPalette remove: color.
		colorPalette isEmpty ifTrue: [colorPalette := self colorPalette asOrderedCollection].
		(joinDictionary at: key) keysAndValuesDo: [:splitKey :splitValue | | splitText splitText2 innerWidth splitGraph |
			innerWidth := splitValue * maxWidth //  maxValue.
			splitGraph := self drawRectangleAt: (x @ y) width: innerWidth height: width stroke: 'black' fillColor: color.
			splitGraph add: (JASVGIAttribute parent: splitGraph name: 'fill-opacity' value: opacity printString).
			opacity := opacity - 0.2.
			splitText := self drawText: splitKey at: ((x + innerWidth + 5) @ (y + 5)) textSizePx: '6px'.
			splitText2 := self drawText: splitValue printString at: ((x + innerWidth + 5)@ (y+12)) textSizePx: '6px'.
			self addFigure: splitGraph toGroup: groupName.
			self addFigure: splitText toGroup: groupName.
			self addFigure: splitText2 toGroup: groupName.
			y := y + width + 5.
		]. 
		"self addFigure: graph toGroup: groupName."
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
		y := y + width.
	].! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/28/2016 08:28'!
drawJoin: joinDictionary verticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width transform: transform
	"The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis yShift group groupName colorPalette |

	groupName := UUID new asString.
	colorPalette := self colorPalette asOrderedCollection.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x + 20.
	maxValue := 0.
	joinDictionary do: [:eachDict | | maxElem |
		maxElem := eachDict asSortedCollection asSortedCollection last.
		(maxElem > maxValue) ifTrue: [maxValue := maxElem]].
	"draw graph axis Y only"
	self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).
	axis := self drawLineFrom: aPoint to: (aPoint x @ (aPoint y -  maxHeight - 20)).
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	yShift := maxHeight // 5.
	1 to: 5 do: [:index | | axisRange line text |
		"draw scale Y bar"
		axisRange := y - (yShift * index) .
		line := self drawLineFrom: ((aPoint x - 5) @ axisRange) to: ((aPoint x + 5) @ axisRange).
		text := self drawText: (maxValue * index // 5) printString at: ((aPoint x - 10) @ (axisRange - 3)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName]. 

	"draw rectangle bars"
	aDictionary keysAndValuesDo: [:key :value | | text text2 graphHeight splitY color opacity |
		text := self drawText: key at: (x @ (y + 25)) textSizePx: '10px'.
		text2 := self drawText: value printString at: (x @ (y + 35)) textSizePx: '10px'.
		graphHeight := value * maxHeight //  maxValue.
		color := colorPalette randomPeek.
		colorPalette remove: color.
		colorPalette isEmpty ifTrue: [colorPalette := self colorPalette asOrderedCollection].
		opacity := 0.5.
		splitY := y.
		(joinDictionary at: key) keysAndValuesDo: [:splitKey :splitValue | | splitText splitText2 innerHeight splitGraph |
			innerHeight := splitValue * maxHeight //  maxValue.
			splitGraph := self drawRectangleAt: (x @ (splitY - innerHeight)) width: width height: innerHeight stroke: 'black' fillColor: color.
			splitGraph add: (JASVGIAttribute parent: splitGraph name: 'fill-opacity' value: opacity printString).
			opacity := opacity + 0.2.
			splitText := self drawText: splitKey at: ((x-5) @ (splitY - innerHeight - 10)) textSizePx: '6px'.
			splitText2 := self drawText: splitValue printString at: ((x + (width//2)) @ (splitY + 8)) textSizePx: '6px'.
			self addFigure: splitGraph toGroup: groupName.
			self addFigure: splitText toGroup: groupName.
			self addFigure: splitText2 toGroup: groupName.
			x := x + width + 5. "separate join bars"
		]. 
		x := x + width.
	"	self addFigure: graph toGroup: groupName."
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
	].! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/20/2016 09:15'!
drawPieAngles: anglesDictionary at: aPoint radius: radius
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawPieAngles: anglesDictionary 
			at: aPoint 
			radius: radius 
			transform: 'translate(', (radius + 20) printString, ',', (radius + 20) printString,')'! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 13:32'!
drawPieAngles: anglesDictionary at: aPoint radius: radius colors: colorsDictionary opacityDictionary: opacityDictionary transform: transform maxValue: maxValue
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."
	| group angleSum startPoint labelsX labelsY random groupName |

	random := Random new.
	startPoint := radius @ 0.
	groupName := UUID new asString.
	group := JASVGITagGroup newNamed: groupName id: UUID new asString.
	group transform: transform.
	svgGroups at: groupName put: group.
	angleSum := 0.
	labelsX := radius + aPoint x + 40.
	labelsY := aPoint y - radius.

	anglesDictionary keysAndValuesDo: [:label :eachAngle | | actualValue line pointsString calculatedPoint color percentage rect text yShift graphText |
		color := colorsDictionary at: label.
		calculatedPoint := self getArcPointFor: eachAngle angleSum: angleSum radius: radius.
		pointsString := PrintStream on: String new.
		pointsString nextPutAll: 'M0,0 '. "center of the circle"
		pointsString nextPutAll: (startPoint x printString, ',', startPoint y printString).
		pointsString nextPutAll: ' A', radius printString, ',',radius printString.
		pointsString nextPutAll: ' 1'.
		(eachAngle > 180) ifTrue: [pointsString nextPutAll: ' 1 0 '] ifFalse: [pointsString nextPutAll: ' 0 0 '].
		yShift := (eachAngle = 360) "360" ifTrue: ['0.5'] ifFalse: [calculatedPoint y printString].
		pointsString nextPutAll: (calculatedPoint x printString, ',', yShift, ' Z').
		line := self drawLine: pointsString contents id: UUID new asString widthPx: '1px' stroke: 'black' fillColor: color.
		line addAttribute: ('opacity'-> (opacityDictionary at: label ifAbsent: [1])).
		self addFigure: line toGroup: groupName.
		angleSum := angleSum + eachAngle.
		startPoint := calculatedPoint.
		rect := self drawRoundRectangleAt: labelsX - 15 @ labelsY width: 15 height: 15 stroke: 'black' fillColor: color.
		self addFigure: rect toGroup: groupName.
		percentage := (eachAngle * 100) / 360.
		actualValue := ((maxValue * percentage) / 100) printShowingDecimalPlaces: 2.
		percentage := percentage printShowingDecimalPlaces: 2.
		graphText := (maxValue = 100) ifTrue: [label, ' - ', percentage,'%'] ifFalse: [label, ' - ', percentage,'% - ', actualValue].
		text := self drawText: graphText at: labelsX @ labelsY + 10.
		self addFigure: text toGroup: groupName.
		labelsY := labelsY + 20.
	].
	^group! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 12:38'!
drawPieAngles: anglesDictionary at: aPoint radius: radius colors: colorsDictionary transform: transform maxValue: maxValue
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawPieAngles: anglesDictionary 
			at: aPoint 
			radius: radius 
			colors: colorsDictionary 
			opacityDictionary: Dictionary new
			transform: transform 
			maxValue: maxValue! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/24/2016 07:44'!
drawPieAngles: anglesDictionary at: aPoint radius: radius transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawPieAngles: anglesDictionary at: aPoint radius: radius transform: transform maxValue: 100! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 11:07'!
drawPieAngles: anglesDictionary at: aPoint radius: radius transform: transform maxValue: maxValue
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawPieAngles: anglesDictionary 
			at: aPoint 
			radius: radius 
			colors: (self getDictionaryColorFor: anglesDictionary)
			transform: transform 
			maxValue: maxValue! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/19/2016 13:36'!
drawPiePercentage: percentageDictionary at: aPoint radius: radius
	"The receiver draw a Pie Graph with values in <percentageDictionary> where the key is the label and the value is the percentage.
	The total sum must be 100.
	The radius of the pie is defined by <radius>."

	^self 
		drawPieAngles: (percentageDictionary collect: [:per | (per * 360) / 100]) "convert percentaje to pie angle"
		at: aPoint
		radius: radius! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/19/2016 15:56'!
drawPiePercentage: percentageDictionary at: aPoint radius: radius transform: transform
	"The receiver draw a Pie Graph with values in <percentageDictionary> where the key is the label and the value is the percentage.
	The total sum must be 100.
	The radius of the pie is defined by <radius>."

	^self 
		drawPieAngles: (percentageDictionary collect: [:per | (per * 360) / 100]) "convert percentaje to pie angle"
		at: aPoint
		radius: radius
		transform: transform! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/24/2016 07:44'!
drawPieQuantity: quantityDictionary at: aPoint radius: radius transform: transform
	"The receiver draw a Pie Graph with values in <quantityDictionary> where the key is the label and the value is the actual value.
	The radius of the pie is defined by <radius>."
	| totalValue |

	totalValue := quantityDictionary inject: 0 into: [:sum :each | sum + each].

	^self 
		drawPieAngles: (quantityDictionary collect: [:value | (value * 360) / totalValue]) "convert percentaje to pie angle"
		at: aPoint
		radius: radius
		transform: transform
		maxValue: totalValue! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:18'!
drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom 

	^self drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom showTotal: true! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/28/2016 08:57'!
drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom showTotal: showTotal
	| xShift yText prevRadius switch group |

	group := JASVGITagGroup newNamed: 'pies'.
	group transform: 'translate(', aPoint x printString, ',', aPoint y printString,')'.
	yText := aPoint y.
	switch := true.

	showTotal 
	ifTrue: [ | circle text |
		circle := self drawCircleAt: aPoint r: (100 * zoom) stroke: 'black' fillColor: self colorPalette randomPeek.
		text := self drawText: 'Total - 100%' at: aPoint.
		self addFigure: circle toGroup: 'pies'.
		self addFigure: text toGroup: 'pies'.
		prevRadius := (100 * zoom).
		xShift := aPoint x + prevRadius]
	ifFalse: [xShift := aPoint x].

	(aBoolean ifTrue: [collectionPercentage asSortedCollection] ifFalse: [collectionPercentage asSortedCollection reverse])
		do: [:eachValue | | key radius circle text |
			yText := switch ifTrue: [aPoint y + 10] ifFalse: [aPoint y - 10].
			key := collectionPercentage keyAtValue: eachValue.
			radius := eachValue * zoom.
			xShift := xShift + radius + 10.
			circle := self drawCircleAt: (xShift @ aPoint y) r: radius stroke: 'black' fillColor: self colorPalette randomPeek.
			text := self drawText: (key, ' ', eachValue printString, '%') at: ((xShift - radius + 10) @ yText).
			self addFigure: circle toGroup: 'pies'.
			self addFigure: text toGroup: 'pies'.
			prevRadius := radius.
			xShift := xShift + prevRadius + 10.
			switch := switch not.
		].! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:05'!
drawPiesAsc: collectionPercentage at: aPoint zoom: zoom

	^self drawPies: collectionPercentage at: aPoint asc: true zoom: zoom! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:19'!
drawPiesAsc: collectionPercentage at: aPoint zoom: zoom showTotal: aBoolean

	^self drawPies: collectionPercentage at: aPoint asc: true zoom: zoom showTotal: aBoolean! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:05'!
drawPiesDesc: collectionPercentage at: aPoint zoom: zoom

	^self drawPies: collectionPercentage at: aPoint asc: false zoom: zoom! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:20'!
drawPiesDesc: collectionPercentage at: aPoint zoom: zoom showTotal: aBoolean

	^self drawPies: collectionPercentage at: aPoint asc: false zoom: zoom showTotal: aBoolean! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/20/2016 04:06'!
drawVerticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width
	"The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
	The witdh of each bar is defined by <width>"

	^self drawVerticalBarGraph: aDictionary 
			at: aPoint 
			maxHeight: maxHeight 
			width: width 
			transform: 'translate(20,', (maxHeight + 20) printString,')'! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 10/12/2016 05:25'!
drawVerticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width transform: transform
    "The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
    The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
    The witdh of each bar is defined by <width>"
    | lateralIndex x y maxValue axis yShift group groupName switch |

    groupName := UUID new asString.
    group := JASVGITagGroup newNamed: groupName.
    group transform: transform.
    svgGroups at: groupName put: group.
    lateralIndex := 1.
    y := aPoint y.
    x := aPoint x + 25.
    maxValue := aDictionary asSortedCollection last.
    "draw graph axis Y only"
    self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
    self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).
    axis := self drawLineFrom: aPoint to: (aPoint x @ (aPoint y -  maxHeight - 20)).
    self addFigure: axis toGroup: groupName.
    axis setMarkerStart: 'circle'.
    axis setMarkerEnd: 'arrow'.
    yShift := maxHeight // 5.
    1 to: 5 do: [:index | | axisRange line text |
        "draw scale Y bar"
        axisRange := y - (yShift * index) .
        line := self drawLineFrom: ((aPoint x - 5) @ axisRange) to: ((aPoint x + 5) @ axisRange).
        text := self drawText: (maxValue * index // 5) printString at: ((aPoint x - 10) @ (axisRange - 3)).
        self addFigure: line toGroup: groupName.
        self addFigure: text toGroup: groupName].

    "draw rectangle bars"
    switch := true.
    aDictionary keysAndValuesDo: [:key :value | | text text2 graph graphHeight textShift |
        textShift := switch ifTrue: [15] ifFalse: [40].
        text := self drawText: key at: (x @ (y + textShift)) textSizePx: '10px'.
        textShift := switch ifTrue: [30] ifFalse: [55].
        text2 := self drawText: value printString at: (x @ (y + textShift)) textSizePx: '10px'.
        switch := switch not.
        graphHeight := value * maxHeight //  maxValue.
        graph := self drawRectangleAt: (x @ (y - graphHeight)) width: width height: graphHeight stroke: 'black' fillColor: self colorPalette randomPeek.
        self addFigure: graph toGroup: groupName.
        self addFigure: text toGroup: groupName.
        self addFigure: text2 toGroup: groupName.
        lateralIndex := lateralIndex + 1.
        x := x + width + 20.
    ].! !

!JASVGIGraphCanvas methodsFor: 'days' stamp: 'BrunoBB 09/30/2016 08:04'!
drawVerticalCurveFrom: startDate for: days r: r id: id strokeWidth: strokeWidth stroke: stroke fillColor: fillColor
	""

	^self drawVerticalCurveFrom: startDate for: days r: r id: id strokeWidth: strokeWidth stroke: stroke fillColor: fillColor xShift: 20 groupedBy: 10! !

!JASVGIGraphCanvas methodsFor: 'days' stamp: 'BrunoBB 09/30/2016 08:01'!
drawVerticalCurveFrom: startDate for: days r: r id: id strokeWidth: strokeWidth stroke: stroke fillColor: fillColor xShift: xShift groupedBy:  anInteger
	""
	|  translatedPoints sortedDays transformString lastPoint axisX axisY marker maxYvalue axisText previousPoint axisXlabel switch dayShift maxDays |

	sortedDays := days asSortedCollection: [:a :b | a y >= b y].
	maxYvalue := sortedDays first y + 30.
	maxDays := sortedDays last x * anInteger.
	transformString := 'translate(20,', maxYvalue printString, ')'.
	translatedPoints := days collect: [:each | (each x * xShift) @ each y negated].

	marker := self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	marker transform: transformString.

	previousPoint := 0@0.
	switch := true.
	dayShift := translatedPoints first x.
	translatedPoints do: [:each | | point line textY textX currentDate |
		dayShift := (dayShift < (each x // xShift)) ifTrue: [dayShift] ifFalse: [dayShift + anInteger].
		currentDate := startDate addDays: dayShift.
		axisXlabel := currentDate day printString, (currentDate monthName first: 3), (currentDate year printString last: 2) .
		point := self drawCircleAt: each r: r  strokeWidth: strokeWidth stroke: stroke fillColor: fillColor.
		textX := self drawText: axisXlabel at: ((each x - 5) @ (switch ifTrue: [10] ifFalse: [20])).
		switch := switch not.
		textY := self drawText: each y abs printString at: ((each x - 5) @ (each y - 10)).
		line := self drawLineFrom: previousPoint to: (point x @ point y).
		previousPoint := (each x @ each y).
		point transform: transformString.
		textY transform: transformString.
		textX transform: transformString.
		line transform: transformString.
	].
	lastPoint := translatedPoints last.

	axisX := self drawLineFrom: (0 @ 0) to: (lastPoint x + 20) @ 0.
	axisX setMarkerEnd: 'arrow'.
	axisX transform: transformString.
	axisText := self drawText: lastPoint x abs printString at: ((lastPoint x + 20) @ -5).
	axisText transform: transformString.

	axisY := self drawLineFrom: (0 @ 0) to: (0 @ (maxYvalue negated + 10)).
	axisY setMarkerEnd: 'arrow'.
	axisY transform: transformString.! !

!JASVGIGraphCanvas methodsFor: 'days' stamp: 'BrunoBB 09/29/2016 11:00'!
drawWorkingDays: workingDays at: aPoint from: startDate to: endDate width: width color: color
	"The receiver draw a vertical working day graph from <startDate> to <endDate> where <workingDays> dictionary key's is the day number and value is the color intensity.
	The width of each rectangle day is <width> and color is <color>"
	
	^self drawWorkingDays: workingDays at: aPoint from: startDate to: endDate width: width color: color dayHasContent: false! !

!JASVGIGraphCanvas methodsFor: 'days' stamp: 'BrunoBB 10/01/2016 11:18'!
drawWorkingDays: workingDays at: aPoint from: startDate to: endDate width: width color: color dayHasContent: aBoolean
	"The receiver draw a vertical working day graph from <startDate> to <endDate> where <workingDays> dictionary key's is the day number and value is the color intensity.
	The width of each rectangle day is <width> and color is <color>"
	| numberOfDays group groupName currentPosition weekCounter maxValue monthName scaleRect scaleText scaleOpacity sortedWorkingDays |

	weekCounter := 0.
	sortedWorkingDays := workingDays asSortedCollection.
	maxValue :=  sortedWorkingDays last.
	groupName := 'verticalWorkingDay'.
	group := JASVGITagGroup newNamed: groupName.
	group transform: 'translate(', aPoint x printString, ',', aPoint y printString, ')'.

	numberOfDays := endDate asDays - startDate asDays.
	currentPosition := aPoint.

	0 to: (numberOfDays - 1) do: [:dayIndex | | value rectDay opacity |
		((startDate addDays: dayIndex) monthName = monthName) 
		ifFalse: [monthName := (startDate addDays: dayIndex) monthName. 
					"draw the name of the months"
					self drawText: (monthName first: 3) at: (currentPosition x @ (aPoint y - 10))].
		weekCounter := weekCounter + 1.
		value := workingDays at: dayIndex ifAbsent: [0].
		opacity := ((value = maxValue) ifFalse: [(value / maxValue) max: 0.05] ifTrue: [1]) asFloat.
		rectDay := ((startDate addDays: dayIndex) day = 1) 
						ifFalse: [self drawRectangleAt: currentPosition width: width height: width stroke: color fillColor: color] 
						ifTrue: [self drawRoundRectangleAt: currentPosition width: width height: width rx: 5 ry: 5 strokeWidth: '1px' stroke: 'darkgreen' fillColor: color].
		rectDay add: (JASVGIAttribute parent: rectDay name: 'opacity' value: opacity).
		self addFigure: rectDay toGroup: groupName.
		(aBoolean and: [value ~= 0]) 
		ifTrue: [self drawText: value printString at: ((currentPosition x + 5) @ (currentPosition y + 12)) color: 'darkgreen']. 
		"draw the named of the days"
		((aPoint x = currentPosition x) and: [weekCounter odd])  "is the first column ?"
		ifTrue: [self drawText: ((startDate addDays: dayIndex) dayOfWeekName first: 3) at: ((aPoint x - 25) @ (currentPosition y + 7))]. 
		(weekCounter = 7)
		ifTrue: [weekCounter := 0.
			dayIndex odd ifTrue: [self drawText: (startDate addDays: dayIndex) day printString at: (currentPosition x @ (currentPosition y + width + 12))].
			currentPosition := (currentPosition x + width + 5) @ aPoint y] 
		ifFalse: [currentPosition := (currentPosition x) @ (currentPosition y + width + 5)].
	].
		currentPosition := aPoint x @ (aPoint y + (7 * width) + 50). 
		scaleRect := self drawRoundRectangleAt: currentPosition width: width height: width stroke: 'darkgreen' fillColor: 'darkgreen'.
		scaleOpacity := ((sortedWorkingDays first / maxValue) max: 0.05) asFloat.
		scaleRect add: (JASVGIAttribute parent: scaleRect name: 'opacity' value: scaleOpacity).
		scaleText := self drawText: sortedWorkingDays first printString at: ((currentPosition x + 5) @ (currentPosition y + 12)) color: 'green'.
		self addFigure: scaleRect toGroup: groupName.
		self addFigure: scaleText toGroup: groupName.

		currentPosition := (aPoint x + width + 5) @ (aPoint y + (7 * width) + 50). 
		scaleRect := self drawRoundRectangleAt: currentPosition width: width height: width stroke: 'darkgreen' fillColor: 'darkgreen'.
		scaleRect add: (JASVGIAttribute parent: scaleRect name: 'opacity' value: 1).
		scaleText := self drawText: maxValue printString at: ((currentPosition x + 5) @ (currentPosition y + 12)) color: 'green'.
		self addFigure: scaleRect toGroup: groupName.
		self addFigure: scaleText toGroup: groupName.! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/20/2016 09:37'!
getArcPointCoordinatesFor: totalAngle radius: radius
	"The rceiver calculate the coordinates for the point in the circle where the angle is <totalAngle> and circle has radius <radius>"
	| x y |

	x := (((totalAngle * DecimalFloat pi) / 180) cos) * radius.

	y := (((totalAngle * DecimalFloat pi) / 180) sin) * radius.

	^x @ y! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/20/2016 09:29'!
getArcPointFor: angle angleSum: angleSum radius: radius
	"Answer the end point <aPoint> for the arc with angle <angle> and circle angle completion <angleSum> with radius <radius> "
	| endPoint totalAngle |

	totalAngle := angleSum + angle. "the angle of the arc is: from <angleSum> to <totalAngle>"
	"formula: 
	x= cos(radian angle) x radius. 											
	y= sin(radian angle) x radius "
	endPoint := self getArcPointCoordinatesFor: totalAngle radius: radius.

	"border cases"
	(totalAngle = 90) ifTrue: [endPoint x: 0; y: radius negated].
	(totalAngle = 270) ifTrue: [endPoint x: 0; y: radius].
 	(totalAngle = 0 or: [totalAngle = 360])  ifTrue: [endPoint y: 0; x: radius].
 	(totalAngle = 180)  ifTrue: [endPoint y: 0; x: radius negated].

	((totalAngle < 90) or: [totalAngle > 270]) 
	ifTrue: [endPoint x: endPoint x abs] 
	ifFalse: [endPoint x: endPoint x abs negated].
	(totalAngle > 180) 
	ifTrue: [endPoint y: endPoint y abs] 
	ifFalse: [endPoint y: endPoint y abs negated].

	^endPoint! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 10/10/2016 13:38'!
getDictionaryColorFor: dictionary
	| colorsDictionary palette random |

	random := Random new.
	colorsDictionary := Dictionary new.
	palette := self colorPalette asOrderedCollection.
	dictionary keys do: [:key | | color |
		color := palette randomPeek: random.
		colorsDictionary at: key put: color.
		palette remove: color ifAbsent: [].
		palette isEmpty ifTrue: [palette := self colorPalette asOrderedCollection]. 
		].

	^colorsDictionary! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 10/10/2016 13:34'!
getDictionaryOpacityColorFor: anglesDictionary subValues: subAnglesDictionary
	""
	| colorsDictionary subColorDictionary opacityDictionary index currentAngle subKeys subValue |

	opacityDictionary := Dictionary new.
	subColorDictionary := Dictionary new.
	currentAngle := 0.
	subValue := 0.
	index := 1.
	colorsDictionary := self getDictionaryColorFor: anglesDictionary.
	subKeys := subAnglesDictionary keys.

	anglesDictionary keysAndValuesDo: [:label :value | | currentCollection opacity |
		currentCollection := OrderedCollection new.
		currentAngle := currentAngle + value.
		opacity := 1.
		[currentAngle > subValue] whileTrue: [
			subValue := subValue + (subAnglesDictionary at: (subKeys at: index)).
			opacity := opacity - 0.2.
			opacityDictionary at: (subKeys at: index) put: opacity.
			subColorDictionary at: (subKeys at: index) put: (colorsDictionary at: label).
			index := index + 1.
		].
	].

	^Array with: colorsDictionary with: subColorDictionary with: opacityDictionary! !
